<?php

namespace Drupal\sys;

use Drupal\Core\Mail\MailManagerInterface;
use Drupal\Core\Render\RendererInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\Component\Utility\Html;
use Drupal\sys\SysService;
use Drupal\Core\Config\ConfigFactoryInterface;


class SendMail {
  protected $mailManager;
  protected $renderer;
  protected $table;
  protected $configFactory;

  public function __construct(MailManagerInterface $mail_manager, RendererInterface $renderer, SysService $table, ConfigFactoryInterface $configFactory) {
    $this->mailManager = $mail_manager;
    $this->renderer = $renderer;
    $this->table = $table;
    $this->configFactory = $configFactory;
  }

  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('plugin.manager.mail'),
      $container->get('renderer'),
      $container->get('sys.service'),
    );
  }

  public function envoyerEmailAvecTableau() {
    $module = 'sys';
    $key = 'sys_sending';
    $langcode = \Drupal::currentUser()->getPreferredLangcode();
    $send = true;
    $config = $this->configFactory->get('sys.settings');
    $emails_to = explode("\n", $config->get('email_to'));
    $params['subject'] = "Sujet de l'email";
    $rows = $this->table->getTables();
    $build = [
      '#theme' => 'email_table',
      '#rows' => $rows
    ];
          
    $params['body'] = Html::escape($this->renderer->renderRoot($build));
    $params['headers'] = ['Content-Type' => 'text/html; charset=UTF-8'];

    foreach($emails_to as $email)
    {
    $this->mailManager->mail($module, $key, $email, $langcode, $params, null, $send);
      
    }
  }
}
